from Products.PageTemplates.ZRPythonExpr import PythonExpr, safe_builtins

_marker = []  # Create a new marker object.

def guarded_getattr(inst, name, default=_marker):
	if name[:1] != '_':
		# Try to get the attribute normally so that unusual
		# exceptions are caught early.
		try: v = getattr(inst, name)
		except AttributeError:
			if default is not _marker:
				return default
			raise
		return v
	raise Unauthorized, name

SliceType = type(slice(0))
def guarded_getitem(object, index):
	if type(index) is SliceType:
		if index.step is not None:
			v = object[index]
		else:
			start = index.start
			stop = index.stop
			if start is None:
				start = 0
			if stop is None:
				v = object[start:]
			else:
				v = object[start:stop]
		# We don't guard slices.
		return v
	v = object[index]
	return v

class PythonExpr(PythonExpr):
	_globals = {'__debug__': __debug__,
				'__builtins__': safe_builtins,
				'_getattr_': guarded_getattr,
				'_getitem_': guarded_getitem,
				}

	
