from cStringIO import StringIO

from ComputedAttribute import ComputedAttribute
from Products.PageTemplates import PageTemplate
from Products.PageTemplates.PageTemplate import PTRuntimeError
from tjTALEngine import tjTALEngine
from ExtensionClass import Base
import sys

class tjPageTemplate(PageTemplate.PageTemplate):

	meta_type = "Compiled Page Template"

	def pt_render(self, source=0, extra_context={}, *args, **kwargs):
		if self._v_errors:
			raise PTRuntimeError, 'Page Template %s has errors.' % self.id

		return self._v_program._exec(extra_context, args, kwargs)

	def _cook_check(self):
		if not self._v_cooked:
			self._cook()
			self._v_cooked = True

	def _cook(self):
		"""Compile the TAL and METAL statments.
		A Page Template must always be cooked, and cooking must not
		fail due to user input.
		"""

		self._v_cook = False
		self._v_errors = []
		try:
			parser = tjTALEngine(self._text, '')
			self._v_program, macros = parser.compile(self.id)
			self._v_macros={}
			for k,v in macros.items():
				self._v_macros[k]=v.__of__(self)
			self._v_cooked = True
		except:
			import traceback
			traceback.print_exc()
			self._v_errors = ["Compilation failed",
							  "%s: %s" % sys.exc_info()[:2]]
			
		self._v_warnings = ()

	def html(self):
		if not hasattr(getattr(self, 'aq_base', self), 'is_html'):
			return self.content_type == 'text/html'
		return self.is_html

	def pt_macros(self):

		self._cook_check()
		
		if self._v_errors:
			raise PTRuntimeError, 'Page Template %s has errors.' % self.id

		return self._v_macros

	macros = ComputedAttribute(pt_macros, 1)

	def write(self, text):
		assert type(text) is type('')
		if text[:len(self._error_start)] == self._error_start:
			errend = text.find('-->')
			if errend >= 0:
				text = text[errend + 4:]
		if self._text != text:
			self._text = text
		self._cook()

	def __call__(self, *args, **kwargs):
		if not kwargs.has_key('args'):
			kwargs['args'] = args
		return self.pt_render(extra_context={'options': kwargs})

	view_code__roles__=('Anonymous',)
	def view_code(self, REQUEST = {}):
		""" View the Code """
		self._cook_check()
		buffer = ''
		for macro in self._v_macros.values():
			buffer = buffer + macro.__name__ + ':\n'
			buffer = buffer + macro.code
		buffer = buffer + '__main__:\n'
		buffer = buffer + self._v_program.code
		if REQUEST:
			REQUEST.RESPONSE.setHeader('Content-Type', 'text/plain')
		return buffer
